Index: reactapp/src/Components/Styled/OpinionCard.style.js
===================================================================
--- reactapp/src/Components/Styled/OpinionCard.style.js	(revision 8dffe022a42c8c6fdea90df3276eb16b6610b51f)
+++ reactapp/src/Components/Styled/OpinionCard.style.js	(revision ebc51762bbd1b4345d8908789af87bdc49aad058)
@@ -8,5 +8,5 @@
   margin-bottom: 20px;
   padding: 10px;
-  box-shadow: 2px 2px 10px #aaaaaa;
+  border: 1px solid black;
 `;
 
@@ -18,5 +18,4 @@
   }
   position: relative;
-  overflow-wrap: break-word;
 `;
 
@@ -56,5 +55,4 @@
   display: block;
   position: absolute;
-  height: 20px;
   top: 50%;
   transform: translateY(-50%);
@@ -62,5 +60,5 @@
   transition: 0.5s;
   &:hover {
-    opacity: 0.5;
+    color: ${(props) => props.color};
     cursor: pointer;
   }
Index: reactapp/src/Components/Styled/ProfessorCard.style.js
===================================================================
--- reactapp/src/Components/Styled/ProfessorCard.style.js	(revision 8dffe022a42c8c6fdea90df3276eb16b6610b51f)
+++ reactapp/src/Components/Styled/ProfessorCard.style.js	(revision ebc51762bbd1b4345d8908789af87bdc49aad058)
@@ -2,8 +2,9 @@
 
 export const ProfessorCard = styled.div`
+  background-color: papayawhip;
   width: auto;
   padding: 10px;
   margin-bottom: 30px;
-  margin-top: 40px;
+  margin-top: 140px;
 `;
 
Index: reactapp/src/Components/UserHeader.js
===================================================================
--- reactapp/src/Components/UserHeader.js	(revision 8dffe022a42c8c6fdea90df3276eb16b6610b51f)
+++ reactapp/src/Components/UserHeader.js	(revision ebc51762bbd1b4345d8908789af87bdc49aad058)
@@ -3,37 +3,13 @@
 import axios from "../api/axios";
 import Logout from "./Logout";
-import LoadingSpinner from "./Styled/LoadingSpinner.style";
 
-function UserHeader({}) {
-  const [user, setUser] = useState(null);
-  const [loadedUser, setLoadedUser] = useState(false);
-  const [fetchError, setFetchError] = useState(false);
-
-  useEffect(() => {
-    const url = `http://192.168.1.108:8080/secure/currentUser`;
-
-    const fetchUser = async () => {
-      try {
-        const response = await axios.get(url, { withCredentials: true });
-        var cyclicGraph = await response.data;
-        var jsogStructure = JSOG.encode(cyclicGraph);
-        cyclicGraph = JSOG.decode(jsogStructure);
-        setUser(cyclicGraph);
-        setLoadedUser(true);
-      } catch (error) {
-        setFetchError(true);
-      }
-    };
-
-    fetchUser();
-  }, []);
-
-  return loadedUser ? (
-    <div style={{ float: "left", marginTop: 20, marginLeft: 10 }}>
+function UserHeader({ user, userLoaded }) {
+  return userLoaded ? (
+    <div style={{ float: "left", marginTop: 20, marginLeft: 40 }}>
       Најавен/а: <a href="/user_dashboard">{user.username}</a> <Logout />{" "}
     </div>
   ) : (
-    <div style={{ float: "left", marginTop: 25, marginLeft: 10 }}>
-      <LoadingSpinner/>
+    <div style={{ float: "left", marginTop: 25, marginLeft: 60 }}>
+      се вчитува...
     </div>
   );
Index: reactapp/src/Pages/Home.js
===================================================================
--- reactapp/src/Pages/Home.js	(revision 8dffe022a42c8c6fdea90df3276eb16b6610b51f)
+++ reactapp/src/Pages/Home.js	(revision ebc51762bbd1b4345d8908789af87bdc49aad058)
@@ -1,136 +1,33 @@
-import React, {useEffect, useState} from 'react';
-import JSOG from "jsog";
-import {OpinionCard, OpinionCardContent, OpinionCardContentTime} from "../Components/Styled/OpinionCard.style";
-import LoadingSpinner from "../Components/Styled/LoadingSpinner.style";
-import {dateConverter} from "../Util/dateConverter";
-import {findParentThread} from "../Util/findParentThread";
-import {CurrentPageNav} from "../Components/Styled/Main.style";
+import React, { useContext } from "react";
+import { MainWrapper, MainTitle } from "../Components/Styled/Main.style";
+import { Outlet } from "react-router-dom";
+import Search from "../Components/Search";
+import UserHeader from "../Components/UserHeader";
+import AuthApi from "../api/AuthApi";
 
-const Home = () => {
-    const [latestOpinions, setLatestOpinions] = useState(null);
-    const [loadedLatestOpinions, setLoadedLatestOpinions] = useState(false);
-    const [latestThreads, setLatestThreads] = useState(null);
-    const [loadedLatestThreads, setLoadedLatestThreads] = useState(false);
+function Home({ user, userLoaded }) {
+  const { auth, setAuth } = useContext(AuthApi);
 
-    useEffect(() => {
-        Promise.all([fetch(`http://192.168.1.108:8080/public/latest10opinions`),
-            fetch(`http://192.168.1.108:8080/public/latest10threads`)])
-            .then(([resOpinions, resThreads]) => Promise.all([resOpinions.json(), resThreads.json()]))
-            .then(([dataOpinions, dataThreads]) => {
-                let cyclicGraph1 = dataOpinions;
-                let jsogStructure1 = JSOG.encode(cyclicGraph1);
-                cyclicGraph1 = JSOG.decode(jsogStructure1);
-                setLatestOpinions(cyclicGraph1);
-                setLoadedLatestOpinions(true);
-
-                let cyclicGraph2 = dataThreads;
-                let jsogStructure2 = JSOG.encode(cyclicGraph2);
-                cyclicGraph2 = JSOG.decode(jsogStructure2);
-                setLatestThreads(cyclicGraph2);
-                setLoadedLatestThreads(true);
-            })
-
-    }, []);
-
-    return (
-        <>
-            <CurrentPageNav>
-                &#187;{" "}
-                <a href={"/university/1"}>
-                    Универзитет „Св. Кирил и Методиј“
-                </a>
-            </CurrentPageNav>
-        <div style={{display:"grid", gridTemplateColumns:"1fr 1fr", gap:"40px", marginTop:"60px"}}>
-
-        <div id="latestOpinions" style={{gridColumn:"1", paddingLeft:"20px"}}>
-            <h2 style={{fontWeight:"normal", marginBottom:"30px"}}>Последни мислења за <span style={{fontWeight:"bold"}}>професори</span></h2>
-            {loadedLatestOpinions ? latestOpinions.slice(5).map(opinion => {
-                opinion.timePosted = undefined;
-                return <OpinionCard key={opinion.postId}>
-                    <OpinionCardContent>
-                        <p style={{marginBottom:"10px"}}>
-                        во дискусија за{" "}
-                        <a href={"/professor/" + opinion.targetProfessor.professorId}>
-                                    {opinion.targetProfessor.professorName}
-                        </a>
-                        </p>
-                        <p style={{ fontStyle: "italic", marginBottom: "10px" }}>
-                            <a href={"/user/" + opinion.author.id}>
-                                {opinion.author.username}
-                            </a>{" "}
-                            напишал
-                        </p>
-                        <p style={{ marginBottom: "10px", maxWidth: "90%" }}>
-                            {opinion.content}
-                        </p>
-                        {new Date(opinion.timePosted).setMilliseconds(0) === new Date(opinion.timeLastEdited).setMilliseconds(0) ? (
-                            <OpinionCardContentTime>
-                                {dateConverter(
-                                    new Date(opinion.timePosted).toString().slice(4, -43)
-                                )} <span style={{fontStyle:"normal",color:"blue"}}>#{opinion.postId}</span>
-                            </OpinionCardContentTime>
-                        ) : (
-                            <OpinionCardContentTime>
-                                {dateConverter(
-                                    new Date(opinion.timeLastEdited)
-                                        .toString()
-                                        .slice(4, -43)
-                                )}{" "} <span style={{fontStyle:"normal",color:"blue"}}>#{opinion.postId}</span>{" "}
-                                (едитирано од модератор)
-                            </OpinionCardContentTime>
-                        )}
-                    </OpinionCardContent>
-                </OpinionCard>
-            }) : <LoadingSpinner/>}
-        </div>
-
-    <div id="latestThreads" style={{gridColumn:"2", paddingRight:"20px"}}>
-        <h2 style={{fontWeight:"normal", marginBottom:"30px"}}>Последни мислења за <span style={{fontWeight:"bold"}}>предмети</span></h2>
-        {loadedLatestThreads ? latestThreads.slice(5).map(thread => {
-            return <OpinionCard key={thread.postId}>
-                <OpinionCardContent>
-                    <p style={{marginBottom:"10px"}}>
-                        во дискусија за{" "}
-                        <a href={
-                                thread.parent === null
-                                    ? "/topic/" + thread.postId
-                                    : "/topic/" + findParentThread(thread).postId
-                            }
-                        > {thread.targetSubject.subjectName}
-                        </a>
-                    </p>
-                    <p style={{ fontStyle: "italic", marginBottom: "10px" }}>
-                        <a href={"/user/" + thread.author.id}>
-                            {thread.author.username}
-                        </a>{" "}
-                        напишал
-                    </p>
-                    <p style={{ marginBottom: "10px", maxWidth: "90%" }}>
-                        {thread.content}
-                    </p>
-                    {new Date(thread.timePosted).setMilliseconds(0) === new Date(thread.timeLastEdited).setMilliseconds(0) ? (
-                        <OpinionCardContentTime>
-                            {dateConverter(
-                                new Date(thread.timePosted).toString().slice(4, -43)
-                            )} <span style={{fontStyle:"normal",color:"blue"}}>#{thread.postId}</span>
-                        </OpinionCardContentTime>
-                    ) : (
-                        <OpinionCardContentTime>
-                            {dateConverter(
-                                new Date(thread.timeLastEdited)
-                                    .toString()
-                                    .slice(4, -43)
-                            )}{" "} <span style={{fontStyle:"normal",color:"blue"}}>#{thread.postId}</span>{" "}
-                            (едитирано од модератор)
-                        </OpinionCardContentTime>
-                    )}
-                </OpinionCardContent>
-            </OpinionCard>
-        }) : null}
-    </div>
-        </div>
-        </>
-    );
-};
+  return (
+    <MainWrapper>
+      <style>
+        @import
+        url('https://fonts.googleapis.com/css2?family=Roboto+Mono:ital,wght@0,400;0,500;0,700;1,400;1,500;1,700&display=swap');
+      </style>
+      <style>
+        {
+          "body { background-color: papayawhip;} * {margin: 0; padding: 0; box-sizing: border-box;}"
+        }
+      </style>
+      <a href="/">
+        <MainTitle>profesori.mk</MainTitle>
+      </a>{" "}
+      <Search />
+      {auth && <UserHeader user={user} userLoaded={userLoaded} />}
+      <div style={{ marginTop: "140px" }}></div>
+      <Outlet />
+    </MainWrapper>
+  );
+}
 
 export default Home;
Index: reactapp/src/Pages/Login.js
===================================================================
--- reactapp/src/Pages/Login.js	(revision 8dffe022a42c8c6fdea90df3276eb16b6610b51f)
+++ reactapp/src/Pages/Login.js	(revision ebc51762bbd1b4345d8908789af87bdc49aad058)
@@ -4,5 +4,4 @@
 import axios from "../api/axios";
 import Cookies from "js-cookie";
-import { LoginButton, LoginInput } from "../Components/Styled/Login.style";
 const LOGIN_URL = "/login";
 
@@ -17,5 +16,5 @@
 
   useEffect(() => {
-    if (!auth) userRef.current.focus();
+    userRef.current.focus();
   }, []);
 
@@ -35,8 +34,5 @@
     if (!response.request.responseURL.includes("error")) {
       // ako NE redirektira na /login?error
-      var in30Minutes = 1 / 48;
-      Cookies.set("JSESSIONID", response.data.sessionId, {
-        expires: in30Minutes,
-      });
+      Cookies.set("JSESSIONID", response.data.sessionId);
       setAuth(true);
       setErrMsg("");
@@ -52,29 +48,12 @@
     <Navigate to="/user_dashboard" />
   ) : (
-    <div
-      style={{
-        marginTop: "140px",
-        display: "flex",
-        alignItems: "center",
-        flexFlow: "column",
-        width: "fit-content",
-        margin: "auto",
-        border: "2px solid lightgrey",
-        padding: "25px",
-        boxShadow: "2px 2px 6px #aaaaaa",
-        marginBottom: "80px",
-      }}
-    >
-      <h2>Најава</h2>
-      <form
-        onSubmit={handleSubmit}
-        style={{
-          display: "flex",
-          flexDirection: "column",
-          alignItems: "center",
-          width: "400px",
-        }}
-      >
-        <LoginInput
+    <div style={{ marginTop: "140px" }}>
+      <p ref={errRef} className={errMsg ? "errmsg" : "offscreen"}>
+        {errMsg}
+      </p>
+      <h1>Најава</h1>
+      <form onSubmit={handleSubmit}>
+        <label htmlFor="username">E-mail:</label>
+        <input
           type="text"
           id="username"
@@ -84,26 +63,15 @@
           value={username}
           required
-          placeholder="Email"
         />
-        <LoginInput
+        <label htmlFor="password">Лозинка:</label>
+        <input
           type="password"
           id="password"
           onChange={(e) => setPassword(e.target.value)}
           value={password}
-          placeholder="Лозинка"
           required
         />
-        <LoginButton>Најави се</LoginButton>
-        <p
-          ref={errRef}
-          className={errMsg ? "errmsg" : "offscreen"}
-          style={{ color: "red", marginTop: "20px" }}
-        >
-          {errMsg}
-        </p>
+        <button>Најави се</button>
       </form>
-      <p style={{ marginTop: "20px" }}>
-        Немаш сметка? <a href="/registration">Регистрирај се</a>{" "}
-      </p>
     </div>
   );
Index: reactapp/src/Pages/Professor.js
===================================================================
--- reactapp/src/Pages/Professor.js	(revision 8dffe022a42c8c6fdea90df3276eb16b6610b51f)
+++ reactapp/src/Pages/Professor.js	(revision ebc51762bbd1b4345d8908789af87bdc49aad058)
@@ -23,46 +23,38 @@
 import { useNavigate } from "react-router-dom";
 import axios from "../api/axios";
-import { CurrentPageNav } from "../Components/Styled/Main.style";
-import LoadingSpinner from "../Components/Styled/LoadingSpinner.style";
 
-function Professor() {
+function Professor(user, userLoaded) {
   let params = useParams();
+
+  let [professor, setProfessor] = useState(null);
+  let [loaded, setLoaded] = useState(null);
+  let [postModalDisplay, setPostModalDisplay] = useState("none");
   let navigate = useNavigate();
-
-  const [professor, setProfessor] = useState(null);
-  const [loadedProfessor, setLoadedProfessor] = useState(false);
-  const [relatedOpinions, setRelatedOpinions] = useState(null);
-  const [loadedRelatedOpinions, setLoadedRelatedOpinions] = useState(false);
-
-  const [postModalDisplay, setPostModalDisplay] = useState("none");
   const { auth, setAuth } = useContext(AuthApi);
+  const [postTitle, setPostTitle] = useState("");
   const [postContent, setPostContent] = useState("");
-  const [fetchError, setFetchError] = useState(false);
-  const [errorMessage, setErrorMessage] = useState("");
 
   useEffect(() => {
-     Promise.all([fetch(`http://192.168.1.108:8080/public/professor/${params.professorId}`),
-     fetch(`http://192.168.1.108:8080/public/professor/${params.professorId}/relatedOpinions`)])
-        .then(([resProfessor, resRelatedOpinions]) => Promise.all([resProfessor.json(), resRelatedOpinions.json()]))
-        .then(([dataProfessor, dataRelatedOpinions]) => {
-          let cyclicGraph1 = dataProfessor;
-          let jsogStructure1 = JSOG.encode(cyclicGraph1);
-          cyclicGraph1 = JSOG.decode(jsogStructure1);
-          setProfessor(cyclicGraph1);
-          setLoadedProfessor(true);
+    const url = `http://192.168.0.17:8080/public/professor/${params.professorId}`;
 
-          let cyclicGraph2 = dataRelatedOpinions;
-          let jsogStructure2 = JSOG.encode(cyclicGraph2);
-          cyclicGraph2 = JSOG.decode(jsogStructure2);
-          setRelatedOpinions(cyclicGraph2);
-          setLoadedRelatedOpinions(true);
-        })
+    const fetchData = async () => {
+      try {
+        const response = await fetch(url);
+        var cyclicGraph = await response.json();
+        var jsogStructure = JSOG.encode(cyclicGraph);
+        cyclicGraph = JSOG.decode(jsogStructure);
+        setProfessor(cyclicGraph);
+        setLoaded(true);
+      } catch (error) {
+        console.log("Fetching error", error);
+      }
+    };
 
-  }, []);
+    fetchData();
+  }, [params.professorId]);
 
   const handleAddOpinionButtonClick = () => {
     if (auth) {
       setPostModalDisplay("block");
-      document.body.style.overflowY = "hidden";
     } else {
       navigate("/login");
@@ -72,5 +64,4 @@
   const handleModalCloseClick = () => {
     setPostModalDisplay("none");
-    document.body.style.overflowY = "auto";
   };
 
@@ -78,20 +69,21 @@
     e.preventDefault();
 
-    if (!postContent.length < 1) {
-      const response = await axios(
-        `http://192.168.1.108:8080/secure/professor/${params.professorId}/addOpinion`,
-        {
-          method: "post",
-          data: {
-            content: postContent,
-          },
-          withCredentials: true,
-        }
-      );
-      setErrorMessage("");
-      window.location.reload();
-    } else {
-      setErrorMessage("Полето за содржина не смее да биде празно");
-    }
+    const response = await axios(
+      `http://192.168.0.17:8080/secure/professor/${professor.professorId}/addOpinion`,
+      {
+        method: "post",
+        data: {
+          title: postTitle,
+          content: postContent,
+        },
+        withCredentials: true,
+      }
+    );
+
+    window.location.reload(false);
+  };
+
+  const handleTitleChange = (e) => {
+    setPostTitle(e.target.value);
   };
 
@@ -100,20 +92,9 @@
   };
 
-  if (loadedProfessor) {
+  if (loaded) {
     return (
       <div>
-        <CurrentPageNav>
-          &#187;{" "}
-          <a href={"/university/" + professor.faculty.university.universityId}>
-            {professor.faculty.university.universityName}
-          </a>{" "}
-          &#187;{" "}
-          <a href={"/faculty/" + professor.faculty.facultyId}>
-            {professor.faculty.facultyName}
-          </a>{" "}
-          &#187; <a href="#">{professor.professorName}</a>
-        </CurrentPageNav>
         <ProfessorCard>
-          <ProfessorCardName>{professor.professorName} <span style={{opacity:"50%", fontSize:"16px"}}>#{professor.professorId}</span></ProfessorCardName>
+          <ProfessorCardName>{professor.professorName}</ProfessorCardName>
           <ProfessorCardSeparator />
           <div style={{ marginTop: "10px" }}>
@@ -126,5 +107,5 @@
           </div>
         </ProfessorCard>
-        <div style={{ height: "20px", marginBottom: "50px" }}>
+        <div style={{ height: "20px", marginBottom: "30px" }}>
           <h3
             style={{
@@ -132,6 +113,6 @@
             }}
           >
-            {relatedOpinions.length}{" "}
-            {relatedOpinions.length !== 1 ? "мислења" : "мислење"}
+            {professor.relatedOpinions.length}{" "}
+            {professor.relatedOpinions.length !== 1 ? "мислења" : "мислење"}
           </h3>
           {auth && (
@@ -152,4 +133,13 @@
             <form onSubmit={handlePostSubmit}>
               <ModalBody>
+                <label htmlFor="title">
+                  <b>Наслов</b>:
+                  <ModalInput
+                    id="title"
+                    type="text"
+                    value={postTitle}
+                    onChange={handleTitleChange}
+                  />
+                </label>
                 <label htmlFor="content">
                   <b>Содржина</b>:
@@ -158,5 +148,4 @@
                     rows="8"
                     cols="100"
-                    spellCheck={false}
                     value={postContent}
                     onChange={handleContentChange}
@@ -164,9 +153,4 @@
                 </label>
               </ModalBody>
-              <p
-                style={{ color: "red", marginLeft: "15px", marginTop: "10px" }}
-              >
-                {errorMessage}
-              </p>
               <ModalFooter type="submit">ОБЈАВИ</ModalFooter>
             </form>
@@ -175,13 +159,10 @@
 
         <div className="opinionTree">
-          <OpinionTree professor={professor} relatedOpinions={relatedOpinions}/>
+          <OpinionTree
+            professor={professor}
+            user={user}
+            userLoaded={userLoaded}
+          />
         </div>
-        <Outlet />
-      </div>
-    );
-  } else if (!fetchError) {
-    return (
-      <div>
-        <LoadingSpinner style={{ marginTop: "140px" }}/>
         <Outlet />
       </div>
@@ -189,6 +170,7 @@
   } else {
     return (
-      <div style={{ marginTop: "140px" }}>
-        <h1 style={{ textAlign: "center" }}>Страницата не е пронајдена.</h1>
+      <div>
+        <p style={{ marginTop: "140px" }}>се вчитува...</p>
+        <Outlet />
       </div>
     );
Index: reactapp/src/Pages/SearchResults.js
===================================================================
--- reactapp/src/Pages/SearchResults.js	(revision 8dffe022a42c8c6fdea90df3276eb16b6610b51f)
+++ reactapp/src/Pages/SearchResults.js	(revision ebc51762bbd1b4345d8908789af87bdc49aad058)
@@ -14,12 +14,12 @@
     <SearchResultsWrapper>
       <h3 style={{ marginBottom: "30px" }}>Резултати од пребарувањето:</h3>
-      {location.state.map((match) => (
-        <SearchResult key={match.professorId !== undefined ? match.professorId : match.subjectId} margin="10px">
-          <SearchResultLink href={`/${match.professorId !== undefined ? 'professor': 'subject'}/` + `${match.professorId !== undefined ? match.professorId : match.subjectId}`}>
+      {location.state.map((professor) => (
+        <SearchResult key={professor.professorId} margin="10px">
+          <SearchResultLink href={"/professor/" + professor.professorId}>
             <SearchResultText weight="bold" size="medium">
-              {match.professorId !== undefined ? match.professorName : match.subjectName}
+              {professor.professorName}
             </SearchResultText>
             <SearchResultText weight="normal" size="er">
-              {match.professorId !== undefined ? match.faculty.facultyName : match.studyProgramme.faculty.facultyName}
+              {professor.faculty.facultyName}
             </SearchResultText>
           </SearchResultLink>
